/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package sfactor;

import java.util.ArrayList;
import java.util.Iterator;

/**
 *
 * @author ranjie
 */
public class ResultConverter {

    public static void displayList(ArrayList<String> aList)
    {


        Iterator<String> outComeItertor = aList.iterator();
         while( outComeItertor.hasNext() )
        {
            //System.out.println("------------------------------");
            System.out.println(outComeItertor.next().toString());
        }
    }

    public static void displayPolyRecords(ArrayList<PolynomialRecord> polynomials){
        int polyCount = 0;
        for (PolynomialRecord poly : polynomials )
        {
            System.out.println("------record " + polyCount + "------------");
            System.out.println("graphID: " + poly.getId());

            String id = poly.getId();
            ArrayList<Factor> factorsList = poly.getFactorsList();
            int factorCount=0;
            for (Factor afactor : factorsList){
                System.out.print(factorCount + ": body=" + afactor.getBody());
                System.out.println("  power=" + afactor.getPower());
                factorCount++;
            }
            polyCount++ ;
        }
    }

    public static void displayPolynomial(PolynomialRecord poly){

            System.out.println("graphID: " + poly.getId());

            String id = poly.getId();
            ArrayList<Factor> factorsList = poly.getFactorsList();
            int factorCount=0;
            for (Factor afactor : factorsList){
                System.out.print(factorCount + ": body=" + afactor.getBody());
                System.out.println("  power=" + afactor.getPower());
                factorCount++;
            }

    }
    
    public static void displayPolyIDs(PolyIDs poly){
            System.out.println("Polynomial: ");
            System.out.println("Factors: ");      
            ArrayList<Factor> factorsList = poly.getFactorsList();
            for (Factor afactor : factorsList){
                System.out.println("(" + afactor.getBody()+")"+"^"+ afactor.getPower());
            }           
            ArrayList<String> IDs = poly.getIDs();
            System.out.println("same polynomial graphs: ");
            for (String ID : IDs){
                System.out.println("Graph:"+ID);
            }
    }

    public static void play1() {
        ArrayList<PolynomialRecord> polynomialsList = new ArrayList<PolynomialRecord>();
        Factor factor1 = new Factor();
        factor1.setBody("1+p");
        factor1.setPower(2);

        Factor factor2 = new Factor();
        factor2.setBody("1+2p");
        factor2.setPower(2);

        Factor factor3 = new Factor();
        factor3.setBody("3+3p");
        factor3.setPower(3);

        PolynomialRecord poly1 = new PolynomialRecord();
        poly1.getFactorsList().add(factor1);
        poly1.getFactorsList().add(factor2);
        poly1.setId("10100101");

        PolynomialRecord poly2 = new PolynomialRecord();
        poly2.getFactorsList().add(factor3);
        poly2.setId("111111101");

        polynomialsList.add(poly1);
        polynomialsList.add(poly2);

        displayPolyRecords(polynomialsList);
        //FileIO.saveResultPari(resultList, "pariCode.txt");
    }


    public static void Test1()
    {
        ArrayList<String> resultList = FileIO.readFileGetStrings("pariResult.txt");
        //ArrayList<String> graphList = FileIO.readFileGetStrings("graphList.txt");
        //FileIO.displayList(graphList);
        //List of graphs ready
        displayList(resultList);

            //Data String

        //Split data into an array
        for (String row : resultList )
        {
            String[] values = row.split("=");
                  System.out.println(values[0]);
        }
    }


    public static Factor strToFactor(String factorPower) {
        String afactor = factorPower;


        String[] cutHead = afactor.split("\\[");//cut head {},{ p - 1 2]} 
        String rightStr = cutHead[1];//{ p - 1 2]}
        String[] cutTail = rightStr.split("\\]");//{ p - 1 2},{}
        String middleStr = cutTail[0];//{p - 1}

        int cutIndex = middleStr.lastIndexOf(" ");
        String body = middleStr.substring(0, cutIndex);
        body = body.replaceAll(" ","");
        String power = middleStr.substring(cutIndex);
        power = power.replaceAll(" ","");

        //System.out.println("body---"+body);
        //System.out.println("power--" +power);

        String factor[] = new String[2];
        factor[0] = body;
        factor[1] = power;
        
        Factor newFactor = new Factor();
        newFactor.setBody(factor[0]);
        int tempPower = Integer.parseInt(factor[1]);
        newFactor.setPower(tempPower);

        return newFactor;



         //System.out.println(java.util.Arrays.toString( cutHead  ));
        // System.out.println("0---"+cutHead[0]);
        // System.out.println("1----"+cutHead[1]);
         //   if (values.length > 1 ){
                  //System.out.println("section " + " is "+ values[1] + "");
          //     System.out.println(values[1]);
         //   } else {
         //   }
       // }
        //FileIO.saveResultPari(resultList, "pariCode.txt");
    }
    
    public static Factor strToFactorPolyIDs(String factorString) {
        String afactor = factorString;  //(p-1)^2
        
        String[] cutHead = afactor.split("\\(");//cut head {},{ p-1)^2 } 
        String rightStr = cutHead[1];//{ p-1)^2 }
        String[] cutTail = rightStr.split("\\)\\^");//{p-1},{2}
        String factorBody = cutTail[0];
        String factorPower = cutTail[1];
           
        Factor newFactor = new Factor();
        newFactor.setBody(factorBody);
        int intPower = Integer.parseInt(factorPower);
        newFactor.setPower(intPower);

        return newFactor;
    }

    
    public static void test2(String[] args) {
        Factor test = strToFactor("  [2*p^4 - 2*p^3 - 3*p^2 + 3*p + 1 1]   ");
        System.out.println("body---"+test.getBody());
        System.out.println("power--" +test.getPower());

    }
    
    public static ArrayList<PolynomialRecord> pariResultToPolynomials(String pariResultPath) {
        ArrayList<String> inputList = FileIO.readFileGetStrings(pariResultPath);
        
        ArrayList<PolynomialRecord> polynomialsList = new ArrayList<PolynomialRecord>();

        int countPoly = 0;
        for ( String line : inputList ){
            if ( line.indexOf("=") != -1 && line.indexOf("%") != -1){// [0;36m%1 = [0;35m ,start a new empty polynomial
                PolynomialRecord newPoly = new PolynomialRecord();
                polynomialsList.add(newPoly);
                countPoly++ ; //1
            } else if ( line.indexOf("]") != -1 && line.indexOf("]") == line.length() - 1) {
                // is a factor
                strToFactor(line);//convert this line to a factor
                // insert to current working polynomial
                Factor lineFactor = strToFactor(line);

                polynomialsList.get(countPoly-1).getFactorsList().add(lineFactor);//index=num-1

            }

        }// all line checked, polynomialsList ready
        //displayPolyRecords(polynomialsList);
        
        return polynomialsList;
    }
    
    public static ArrayList<PolyIDs> pariResultToPolyIDsRaw(String pariResultPath) {
        ArrayList<String> inputList = FileIO.readFileGetStrings(pariResultPath);
        
        ArrayList<PolyIDs> polynomialsList = new ArrayList<PolyIDs>();

        int countPoly = 0;
        for ( String line : inputList ){
            if ( line.indexOf("=") != -1 && line.indexOf("%") != -1){// [0;36m%1 = [0;35m ,start a new empty polynomial
                PolyIDs newPoly = new PolyIDs();
                polynomialsList.add(newPoly);
                countPoly++ ; //1
            } else if ( line.indexOf("]") != -1 && line.indexOf("]") == line.length() - 1) {
                // is a factor
                strToFactor(line);//convert this line to a factor
                // insert to current working polynomial
                Factor lineFactor = strToFactor(line);;

                polynomialsList.get(countPoly-1).getFactorsList().add(lineFactor);//index=num-1

            }

        }// all line checked, polynomialsList ready
        //displayPolyRecords(polynomialsList);
        
        return polynomialsList;
    }

    
     public static ArrayList<PolynomialRecord> Normalization(String graphListPath, String pariResultPath) {
        ArrayList<PolynomialRecord> polynomialsList = pariResultToPolynomials(pariResultPath);
        

        //add graph ID to polynomialsList
        ArrayList<String> graphList = FileIO.readFileGetStrings(graphListPath);

        if (polynomialsList.size() != graphList.size()){
            System.out.println("graphList and pariResult is not matched");
        } else {
            for ( int i = 0; i < graphList.size(); i++){
               String graphId = graphList.get(i);
               polynomialsList.get(i).setId(graphId);
            }
        }
        
        //displayPolyRecords(polynomialsList);
        return polynomialsList;

    }
     
     public static ArrayList<PolyIDs> InitializePolyIDsList (String graphListPath, String pariResultPath) {
        //one graph - one polynomial
         ArrayList<PolyIDs> polynomialsList = pariResultToPolyIDsRaw(pariResultPath);
        
        //add graph ID to polynomialsList
        ArrayList<String> graphList = FileIO.readFileGetStrings(graphListPath);

        if (polynomialsList.size() != graphList.size()){
            System.out.println("graphList and pariResult is not matched");
        } else {
            for ( int i = 0; i < graphList.size(); i++){
               String graphId = graphList.get(i);
               polynomialsList.get(i).getIDs().add(graphId);
            }
        }
        
        //displayPolyRecords(polynomialsList);
        return polynomialsList;
    }

    public static ArrayList<String> sfactorToAdjMatrixs(String aSFactor) {

        ArrayList<String> adjMatrixSet = new ArrayList<String>();
        String productGraph = aSFactor.split("=")[0];
        String factors = aSFactor.split("=")[1];
        String factor1 = factors.split("X")[0];
        String factor2 = factors.split("X")[1];

        ArrayList<String> productMatrix = GraphConverter.matrixToAdj(GraphConverter.idToMatrix(productGraph) );
        ArrayList<String> factor1Matrix = GraphConverter.matrixToAdj(GraphConverter.idToMatrix(factor1) );
        ArrayList<String> factor2Matrix = GraphConverter.matrixToAdj(GraphConverter.idToMatrix(factor2) );

        adjMatrixSet.add("---- "+ productGraph + " ----");
        for (String item : productMatrix){
            adjMatrixSet.add(item);
        }
        adjMatrixSet.add("---- "+ factor1 + " ----");
        for (String item : factor1Matrix){
            adjMatrixSet.add(item);
        }
        adjMatrixSet.add("---- "+ factor2 + " ----");
        for (String item : factor2Matrix){
            adjMatrixSet.add(item);
        }

        return adjMatrixSet;

    }


    public static void main(String[] args) {

        //ArrayList<PolynomialRecord> polynomialsList = Normalization("graphList.txt","pariResult.txt");
        //displayPolyRecords(polynomialsList);
        //ArrayList<String> test = sfactorToAdjMatrixs("010111010110101010010=1X011010111011011");
        //FileIO.displayList(test);
        ArrayList<PolynomialRecord> tt = pariResultToPolynomials("running/pariResult.txt");
        System.out.print(tt.size());
        
    }

}
